#include "tree.h"
#include <math.h>

#ifndef M_PI
	#define M_PI 3.14159265358979323846
#endif


int rndr(int range) { return 1 + (int)((float(range)*rand()/(RAND_MAX+1.0))); }	// random number in 1..range
int rndb(int range) {int r = rndr(2*range); return (r - range); }	// random num in -range..range

Tree::Tree(int age, float length) {
	_age = age;
	_length = length;
	branch = new_trunk(age, length);
}

Tree::~Tree() {
}

Branch* Tree::new_trunk(int age, float length) {
	if (length <= 0.01 || age <= 0) return NULL;	// don't waste time drawing very small twigs
	
	Branch* b = new Branch;

	// A COMPLETER!!!
	
	return b;
}

Branch* Tree::new_branch(int age, float length, int angle, bool ppal_branch) {
	if (length <= 0.01 || age <= 0) return NULL;	// don't waste time drawing very small twigs

	Branch* b = new Branch;

	// A COMPLETER!!!
	
	return b;
}


void Tree::drawBranchObject(float length, float thick) {
	glBindTexture( GL_TEXTURE_2D, textureTronc );

	glColor3f(0.6,0.3,0.0);

	glPushMatrix();
	
	float r= thick;
	float l=length;
	int sl=12;
	
	GLUquadricObj* q = gluNewQuadric();

	gluQuadricTexture( q, GL_TRUE );

	gluCylinder(q, r, r, l, sl, 1);

	gluDeleteQuadric( q );

	glPopMatrix();
}

void Tree::draw_branch(Branch* b) {
	if (b == NULL) return;

	float angle_vert, thick;

	float length = b->length;
	length = length*0.67 + length*0.33*(float)(b->age)/_age;

	if (b->trunk)	{
		angle_vert =  b->angle_vert;
		thick = 0.025 + b->age*0.009;
	}
	else {
		angle_vert =  int(70.0/(b->age+.01) * (1 + b->angle_vert/100.0));
		if (angle_vert > 80) angle_vert = 80;
		thick = (!b->ppal_branch && !b->trunk) ? 0.02 : 0.02 + (b->age)*0.006;
	}

	glPushMatrix();

	glRotatef(b->angle_horiz, 0, 1, 0 );
	glRotatef(-angle_vert, 1.0, 0.0, 0.0 );
	drawBranchObject(length, thick);
	glTranslatef(0,0,length);

	glRotatef(angle_vert, 1.0, 0.0, 0.0 );
	glRotatef(-b->angle_horiz, 0, 1, 0 );

	if (b->twigs.size() == 0) {
		draw_leaves(b);
	}

	for (list<Branch*>::iterator bi = b->twigs.begin(); bi != b->twigs.end(); bi++) {
		draw_branch(*bi);
	}

	glPopMatrix();
}

void Tree::draw_leaves(Branch* b) {
	glColor3f(0.3,0.6,0.0);
	
	glDisable( GL_TEXTURE_2D );
	glDisable(GL_LIGHTING);
	glLineWidth( 1.0f );
	glBegin(GL_LINES);
	float i2, j2;
	int xspread = (b->age==0) ? 180 : 54;
	for (int i= b->angle_horiz - xspread; i<= b->angle_horiz + xspread; i+=18) { 	// spread of angles horizontally
		for (int j=0; j <= 6; j++) {	// spread of angles vertically
			glVertex3f(0.0, 0.0, 0.0);
			i2 =( i + 12) * 3.14159265/180.0;
			j2 = (10 + j*10 + 12) * 3.14159265/180.0;
			glVertex3f(branch->length*0.4 * sin(i2) * cos(j2), -branch->length*0.4 * sin(j2), branch->length*0.4 * cos(i2) * cos(j2));
		}
	}
	glEnd();
	glEnable(GL_LIGHTING);
	glEnable( GL_TEXTURE_2D );
}

void Tree::drawTree() {
	glTexEnvi(GL_TEXTURE_ENV, GL_TEXTURE_ENV_MODE, GL_MODULATE);
	draw_branch(branch);
}