#ifndef TREE_H
#define TREE_H

//Windows header
#ifdef WIN32
#include <windows.h>
#endif

// OpenGL header
#include "gl.h"
#include "glut.h"


#include <iostream>
#include <stdlib.h>
#include <list>
using namespace std;


struct Branch {
	float length; // longueur de la branche
	bool trunk; // noeud T?
	bool ppal_branch; // noeud P?
	int age; // date de croissance
	int angle_vert;	// angle vertical
	int angle_horiz;	// angle horizontal
	list <Branch*> twigs; // ensemble des noeuds enfants
	
	~Branch();
	void add_twig(Branch* b) { if (b != NULL) twigs.push_back(b); } // ajoute un enfant
};

class Tree {
public :
	int _age;
	float _length;
	GLuint textureTronc;
	Branch* branch; // tronc

public :
	Tree(int age, float length); // cre un arbre d'age age et de longueur length
	~Tree();

	void drawBranchObject(float length, float thick);
	void draw_branch(Branch* b);
	void draw_leaves(Branch* b);
	void drawTree();
		
	// Mthodes  complter :
	Branch* new_trunk(int age, float length); 
	// cre un noeud T d'age age et de longueur length
	// et fait une drivation de plus de la grammaire  partir de ce noeud T
	Branch* new_branch(int age, float length, int angle, bool ppal_branch);
	// cre soit un noeud P (si ppal_branch) ou B (si non ppal_branch) 
	// d'age age, de longueur length et d'angle horizontal angle
	// et fait une drivation de plus de la grammaire  partir de ce noeud si noeud P
};

#endif //TREE_H